{****************************************************************************

                       Copyright (c) 1996 by Florian Klaempfl

 ****************************************************************************}

{ this unit handles inlining of procedures and functions }

{

   * firstcalln calls prepare_for_inline, if the po_inline flag is set for
     the procedure which is called
   * if inlining is possible, prepare_for_inline changes the call node
     to an inline node

}


unit inl;

  interface

    uses
       globals,asmgen,tree;

  implementation

    var
       maxinline_level,inline_level : longint;

    procedure init_inlining;

      begin
         inline_level:=0;
      end;

    procedure prepare_for_inline(var p : ptree);

      var
         code : ptree;

      begin
         { omit recursive inlines }
         if inline_level>=max_inline_level then
           exit;
         { get a copy of the code }
         code:=getcopy(ptree(p^.procdefinition^.code));

      end;


begin
   maxinline_level:=4;
end.

