program make_list;

  uses
     dos;

  procedure error;

    begin
       writeln('Error');
       halt(1);
    end;

  procedure copyfile(const src,dest,f : string);

    const
       maxsize = 65000;

    type
       tbytearray = array[0..maxsize] of byte;

    var
       f1,f2 : file;
       buffer : ^tbytearray;
       l : longint;
       s : string;
       i : word;

    begin
       write('Copying ',f,' from ',src,' to ',dest,' ... ');
       new(buffer);
       assign(f1,src+f);
       {$I-}
       reset(f1,1);
       {$I+}
       if ioresult<>0 then
         error;

       if ioresult<>0 then
         error;
       for l:=1 to length(dest) do
         begin
            {$I-}
            if dest[l]='\' then
               mkdir(copy(dest,1,l-1));
         end;
       mkdir(dest);
       if ioresult<>0 then
         begin
         end;
       { path must be created first }
       assign(f2,dest+'\'+f);
       rewrite(f2,1);

       if ioresult<>0 then
         error;

       repeat
         blockread(f1,buffer^,maxsize,i);
         blockwrite(f2,buffer^,i);
       until i<maxsize;
       close(f2);
       close(f1);
       writeln('OK');
       dispose(buffer);
    end;

  var
     t,p : text;
     s : string;
     srcpath,dest,paket,srcfile : string;
     srcdir : dirstr;
     srcname : namestr;
     srcext : extstr;
     l : longint;

  begin
     assign(t,'FILES.LST');
     reset(t);
     while not(eof(t)) do
       begin
          readln(t,s);

          { handle comments }
          if s[1]<>'#' then
            begin
               l:=1;
               srcpath:='';
               dest:='';
               paket:='';
               while s[l]<>' ' do
                 begin
                    srcpath:=srcpath+s[l];
                    inc(l);
                 end;
               fsplit(srcpath,srcdir,srcname,srcext);
               srcfile:=srcname+srcext;
               inc(l);
               while s[l]<>' ' do
                 begin
                    dest:=dest+s[l];
                    inc(l);
                 end;
               inc(l);
               while l<=length(s) do
                 begin
                    paket:=paket+s[l];
                    inc(l);
                 end;
               { first generate list file ... }
               assign(p,paket+'.LST');
               {$I-}
               reset(p);
               if ioresult<>0 then
                 rewrite(p)
               else
                 begin
                    close(p);
                    append(p);
                 end;
               writeln(p,dest+'\'+srcfile);
               close(p);

               { .... now modify dest }
               if dest<>'' then
                 dest:='\'+dest;
               copyfile(srcdir,'RELEASE'+dest,srcfile);
            end;
       end;
     close(t);
     halt(0);
  end.
