{****************************************************************************

                      Copyright (c) 1996 by Florian Klaempfl

 ****************************************************************************}

{ this unit does the name mangling for FPKPascal }

unit mangle;

  interface

    uses
       symtable;

    type
       { the different name mangling styles: }
       tmangling_style = (nms_normal);

    function get_vmt_name(p : pobjectdef) : string;

    const
       mangling_style : tmangling_style = nms_normal;

  implementation

    function get_vmt_name(p : pobjectdef) : string;

      begin
         case mangling_style of
            nms_normal : get_vmt_name:='VMT_'+p^.methodpointer^.resulttype^.name^;
            else internalerror(30004);
         end;
      end;

end.